diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
index c270f7617..e6f234536 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
@@ -1,71 +1,140 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.model.ModelWolf;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.animal.MobWolf;
-
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 import org.useless.dragonfly.DisplayPos;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererWolf extends MobRenderer<MobWolf>
-{
-    private final ModelWolf modelArmor;
-    protected ModelWolf modelWolfMain;
-
-    public MobRendererWolf(ModelWolf modelWolf, float shadowSize)
-    {
-        super(modelWolf, shadowSize);
-        modelWolfMain = modelWolf;
-        modelArmor = new ModelWolf(0.25f);
+public class MobRendererWolf extends MobRenderer<MobWolf> {
+    public MobRendererWolf(final float shadowSize) {
+        super(shadowSize);
     }
 
     @Override
-    protected boolean prepareArmor(MobWolf wolf, int layer, float partialTick) {
-        ArmorMaterial material = wolf.getArmorMaterial();
-        if (material == null) {
-            return false;
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobWolf entity, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model;
+        if (layer == 1) {
+            final ArmorMaterial material = entity.getArmorMaterial();
+            if (material == null) return null;
+            bindTexture(String.format("/assets/%s/textures/armor/wolf/%s.png", material.identifier.namespace, material.identifier.value));
+            model = getModel("armor");
+        } else {
+            model = getModel("main");
+        }
+        model.resetBones();
+
+        final BoneTransform tail = model.getTransform("tail");
+        final BoneTransform bodyUpper = model.getTransform("upperBody");
+        final BoneTransform body = model.getTransform("body");
+        final BoneTransform head = model.getTransform("head");
+        final BoneTransform leg0 = model.getTransform("leg0");
+        final BoneTransform leg1 = model.getTransform("leg1");
+        final BoneTransform leg2 = model.getTransform("leg2");
+        final BoneTransform leg3 = model.getTransform("leg3");
+
+        final float bodyYaw = getBodyYaw(entity, partialTick);
+        final float headYaw = getHeadYaw(entity, partialTick) - bodyYaw;
+        final float headPitch = getHeadPitch(entity, partialTick);
+        final float limbSwing = getLimbSwing(entity, partialTick);
+        final float limbYaw = getLimbYaw(entity, partialTick);
+        final float limbPitch = getLimbPitch(entity, partialTick);
+
+        if(entity.isWolfAngry())
+        {
+            tail.rotY = 0.0F;
+        } else
+        {
+            tail.rotY = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        }
+        if(entity.isWolfSitting())
+        {
+            body.rotX = -33.5 * MathHelper.DEG_TO_RAD;
+            body.posY = -4.5;
+            body.posZ = -2;
+
+            bodyUpper.rotX = -18 * MathHelper.DEG_TO_RAD;
+            bodyUpper.posY = -3;
+
+            leg0.rotX = -90 * MathHelper.DEG_TO_RAD;
+            leg0.posY = -7;
+            leg0.posZ = -3;
+
+            leg1.rotX = -90 * MathHelper.DEG_TO_RAD;
+            leg1.posY = -7;
+            leg1.posZ = -3;
+
+            leg2.rotX = -22.5 * MathHelper.DEG_TO_RAD;
+            leg2.posY = -1;
+
+            leg3.rotX = -22.5 * MathHelper.DEG_TO_RAD;
+            leg3.posY = -1;
+
+            tail.posY = -9;
+            tail.posZ = -3;
+        } else
+        {
+            leg0.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+            leg1.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+            leg2.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+            leg3.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        }
+        head.rotZ = entity.getInterestedAngle(partialTick) + entity.getShakeAngle(partialTick, 0.0F);
+        bodyUpper.rotZ = entity.getShakeAngle(partialTick, -0.08F);
+        body.rotZ = entity.getShakeAngle(partialTick, -0.16F);
+        tail.rotZ = entity.getShakeAngle(partialTick, -0.2F);
+
+        if(entity.getWolfShaking())
+        {
+            final float shading = brightness * entity.getShadingWhileShaking(partialTick);
+            GL11.glColor3f(shading, shading, shading);
         }
-        bindTexture(String.format("/assets/%s/textures/armor/wolf/%s.png", material.identifier.namespace, material.identifier.value));
-        setArmorModel(modelArmor);
-        return true;
+
+        head.rotX = headPitch;
+        head.rotY = headYaw;
+        tail.rotX = limbPitch;
+
+        return model;
     }
+
     @Override
-    protected float limbSway(MobWolf wolf, float partialTick)
+    protected int maxRenderLayer(@NotNull final MobWolf entity) {
+        return entity.getArmorMaterial() != null ? 1 : 0;
+    }
+
+    @Override
+    protected float getLimbPitch(final @NotNull MobWolf wolf, final float partialTick)
     {
         if(wolf.isWolfAngry())
         {
-            return 88 * (MathHelper.PI / 180F);
+            return 88 * MathHelper.DEG_TO_RAD;
         }
         else if(wolf.isWolfTamed())
         {
             return (0.55F - (float)(wolf.getMaxHealth() - wolf.getHealth()) * 0.02F) * MathHelper.PI;
-        }
-        else
+        } else
         {
-            return 36 * (MathHelper.PI / 180F);
+            return 36 * MathHelper.DEG_TO_RAD;
         }
     }
 
     @Override
-    protected void renderAdditional(MobWolf entity, float partialTick){
-        ItemStack itemstack = entity.getHeldItem();
+    protected void renderAdditional(@NotNull final Tessellator tessellator, final @NotNull MobWolf entity, final float partialTick){
+        final ItemStack itemstack = entity.getHeldItem();
 
-        if(itemstack != null && itemstack.getItem() != null) {
+        if(itemstack != null) {
             GL11.glPushMatrix();
-            modelWolfMain.wolfHeadMain.translateTo(0.0625F);
-            GL11.glScalef(1, -1, 1);
-            GL11.glTranslatef(0.5f/16f, -2.5f/16f, -2/16f);
-            GL11.glRotatef(-2.5f, 0, 0, 1);
-            GL11.glRotatef(45, 0, 1, 0);
-            GL11.glRotatef(-90, 1, 0, 0);
+            getModel("main").translateToBone("mouthItem");
+            GL11.glScalef(MobRenderer.ENTITY_RENDER_SCALE, -MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
             GL11.glEnable(GL12.GL_RESCALE_NORMAL);
             GL11.glEnable(GL11.GL_BLEND);
             ItemModelDispatcher.getInstance().getDispatch(itemstack).render(Tessellator.instance, entity, itemstack, DisplayPos.GROUND, Minecraft.getMinecraft().gameSettings.items3D.value, 1, entity.getBrightness(partialTick), 1f, partialTick, true);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombie.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombie.java
new file mode 100644
index 000000000..a621872ee
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombie.java
@@ -0,0 +1,48 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.core.entity.monster.MobZombie;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+
+public class MobRendererZombie extends MobRendererBipedArmored<MobZombie>{
+
+    public MobRendererZombie(final float shadowSize) {
+        super(shadowSize);
+    }
+
+    @Override
+    protected @Nullable StaticEntityModel getActiveModel(@NotNull final MobZombie entity) {
+        return getModel("main");
+    }
+
+    @Override
+    protected @Nullable StaticEntityModel setupAnimations(@NotNull final MobZombie entity, @Nullable final StaticEntityModel model, final float partialTick, final int layer) {
+        if (model == null) return null;
+        final StaticEntityModel model1 = super.setupAnimations(entity, model, partialTick, layer);
+
+        final BoneTransform rightArm = model.getTransform("rightArm");
+        final BoneTransform leftArm = model.getTransform("leftArm");
+
+        final float limbPitch = getLimbPitch(entity, partialTick);
+        final float swingProgress = entity.getSwingProgress(partialTick);
+
+        final float var7 = MathHelper.sin(swingProgress * MathHelper.PI);
+        final float var8 = MathHelper.sin((1.0F - (1.0F - swingProgress) * (1.0F - swingProgress)) * MathHelper.PI);
+        rightArm.rotZ = 0.0F;
+        leftArm.rotZ = 0.0F;
+        rightArm.rotY = -(0.1F - var7 * 0.6F);
+        leftArm.rotY = 0.1F - var7 * 0.6F;
+        rightArm.rotX = -90 * MathHelper.DEG_TO_RAD;
+        leftArm.rotX = -90 * MathHelper.DEG_TO_RAD;
+        rightArm.rotX -= var7 * 1.2F - var8 * 0.4F;
+        leftArm.rotX -= var7 * 1.2F - var8 * 0.4F;
+        rightArm.rotZ += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        leftArm.rotZ -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        rightArm.rotX += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        leftArm.rotX -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        return model1;
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombieArmored.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombieArmored.java
index fabd18273..47dc66c79 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombieArmored.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombieArmored.java
@@ -1,74 +1,112 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelZombie;
 import net.minecraft.core.entity.monster.MobZombieArmored;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererZombieArmored extends MobRendererBiped<MobZombieArmored>
-{
+public class MobRendererZombieArmored extends MobRendererBipedArmored<MobZombieArmored>{
 
-    private final ModelZombie modelArmorChestplate;
-    private final ModelZombie modelArmor;
+    public MobRendererZombieArmored(final float shadowSize) {
+        super(shadowSize);
+    }
 
-    public MobRendererZombieArmored(ModelZombie model, float shadowSize)
-    {
-        super(model, shadowSize);
-        modelBipedMain = model;
-        modelArmorChestplate = new ModelZombie(1.0F);
-        modelArmor = new ModelZombie(0.5F);
+    @Override
+    protected @Nullable StaticEntityModel getActiveModel(@NotNull final MobZombieArmored entity) {
+        return getModel("main");
     }
 
     @Override
-    protected boolean prepareArmor(MobZombieArmored zombie, int renderPass, float partialTick)
-    {
-        bindTexture("/assets/minecraft/textures/armor/chain" + "_" + (renderPass != 2 ? 1 : 2) + ".png");
-        ModelZombie model = renderPass != 2 ? modelArmorChestplate : modelArmor;
-        model.head.visible = renderPass == 0;
-        model.hair.visible = renderPass == 0;
-        model.body.visible = renderPass == 1 || renderPass == 2;
-        model.armRight.visible = renderPass == 1;
-        model.armLeft.visible = renderPass == 1;
-        model.legRight.visible = renderPass == 2 || renderPass == 3;
-        model.legLeft.visible = renderPass == 2 || renderPass == 3;
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobZombieArmored entity, final float brightness, final float partialTick, final int layer) {
+        if (layer == 0) return setupAnimations(entity, getActiveModel(entity), partialTick, layer);
+
+        bindTexture("/assets/minecraft/textures/armor/chain" + "_" + (layer != 3 ? 1 : 2) + ".png");
 
         // Disable armor pieces depending on health
-        int[] armorBreakPoints = zombie.getArmorBreakPoints();
-        int[] armorBreakOrder = zombie.getArmorBreakOrder();
+        final int[] armorBreakPoints = entity.getArmorBreakPoints();
+        final int[] armorBreakOrder = entity.getArmorBreakOrder();
         for (int i = 0; i < 4; i++)
         {
-            if (zombie.getHealth() <= armorBreakPoints[i])
+            if (entity.getHealth() <= armorBreakPoints[i])
             {
                 hideArmorPiece(armorBreakOrder[i]);
             }
         }
 
-        setArmorModel(model);
-        return true;
+        final StaticEntityModel model;
+        switch (layer) {
+            case 4:
+                model = getModel("armor.boots");
+                break;
+            case 3:
+                model = getModel("armor.leggings");
+                break;
+            case 2:
+                model = getModel("armor.chestplate");
+                break;
+            case 1:
+                model = getModel("armor.helmet");
+                break;
+            default:
+                return null;
+        }
+
+        return setupAnimations(entity, model, partialTick, layer);
     }
 
-    private void hideArmorPiece(int piece)
+    private void hideArmorPiece(final int piece)
     {
-        if (piece == 0)
-        {
-            modelArmorChestplate.head.visible = false;
-            modelArmorChestplate.hair.visible = false;
-        }
-        else if (piece == 1)
-        {
-            modelArmorChestplate.body.visible = false;
-            modelArmorChestplate.armLeft.visible = false;
-            modelArmorChestplate.armRight.visible = false;
-        }
-        else if (piece == 2)
-        {
-            modelArmor.body.visible = false;
-            modelArmor.legLeft.visible = false;
-            modelArmor.legRight.visible = false;
-        }
-        else if (piece == 3)
-        {
-            modelArmorChestplate.legLeft.visible = false;
-            modelArmorChestplate.legRight.visible = false;
-        }
+//        if (piece == 0)
+//        {
+//            modelArmorChestplate.head.visible = false;
+//            modelArmorChestplate.hair.visible = false;
+//        }
+//        else if (piece == 1)
+//        {
+//            modelArmorChestplate.body.visible = false;
+//            modelArmorChestplate.armLeft.visible = false;
+//            modelArmorChestplate.armRight.visible = false;
+//        }
+//        else if (piece == 2)
+//        {
+//            modelArmor.body.visible = false;
+//            modelArmor.legLeft.visible = false;
+//            modelArmor.legRight.visible = false;
+//        }
+//        else if (piece == 3)
+//        {
+//            modelArmorChestplate.legLeft.visible = false;
+//            modelArmorChestplate.legRight.visible = false;
+//        }
     }
 
-}
+    @Override
+    protected @Nullable StaticEntityModel setupAnimations(@NotNull final MobZombieArmored entity, @Nullable final StaticEntityModel model, final float partialTick, final int layer) {
+        if (model == null) return null;
+        final StaticEntityModel model1 = super.setupAnimations(entity, model, partialTick, layer);
+
+        final BoneTransform rightArm = model.getTransform("rightArm");
+        final BoneTransform leftArm = model.getTransform("leftArm");
+
+        final float limbPitch = getLimbPitch(entity, partialTick);
+        final float swingProgress = entity.getSwingProgress(partialTick);
+
+        final float var7 = MathHelper.sin(swingProgress * MathHelper.PI);
+        final float var8 = MathHelper.sin((1.0F - (1.0F - swingProgress) * (1.0F - swingProgress)) * MathHelper.PI);
+        rightArm.rotZ = 0.0F;
+        leftArm.rotZ = 0.0F;
+        rightArm.rotY = -(0.1F - var7 * 0.6F);
+        leftArm.rotY = 0.1F - var7 * 0.6F;
+        rightArm.rotX = -90 * MathHelper.DEG_TO_RAD;
+        leftArm.rotX = -90 * MathHelper.DEG_TO_RAD;
+        rightArm.rotX -= var7 * 1.2F - var8 * 0.4F;
+        leftArm.rotX -= var7 * 1.2F - var8 * 0.4F;
+        rightArm.rotZ += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        leftArm.rotZ -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        rightArm.rotX += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        leftArm.rotX -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        return model1;
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
index bb6df22ad..665a70ba6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
@@ -31,7 +31,11 @@ public class ItemModelBow extends ItemModelStandard {
         }
         if (nextArrow != null){
             GL11.glPushMatrix();
-            GL11.glRotatef(90, 0, 0, 1);
+            if (mirrorX) {
+                GL11.glRotatef(-90, 0, 0, 1);
+            } else {
+                GL11.glRotatef(90, 0, 0, 1);
+            }
             GL11.glTranslatef(0.0001f, 0.0001f, 0);
             GL11.glScalef(1, 1, 0.999f);
             renderCoordinate(tessellator, ItemModelDispatcher.getInstance().getDispatch(nextArrow).getIcon(holder, nextArrow.getDefaultStack()), items3d, mirrorX);
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
index 93c192540..70519b93a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
@@ -3,7 +3,6 @@ package net.minecraft.client.render.item.model;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.MapItemRenderer;
 import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.entity.EntityRenderer;
@@ -62,14 +61,28 @@ public class ItemModelMap extends ItemModelStandard {
             GL11.glRotatef(-45, 1.0F, 0.0F, 0.0F);
             GL11.glRotatef(90F - 59F, 0.0F, 0.0F, 1.0F);
             GL11.glRotatef(65, 0.0F, 1.0F, 0.0F);
-            playerRenderer.drawFirstPersonHand(mc.thePlayer, true);
+            GL11.glPushMatrix();
+            GL11.glScalef(1/16f, 1/16f, -1/16f);
+            GL11.glTranslatef(0, 16, 0);
+            GL11.glRotatef(180, 1, 0, 0);
+            GL11.glTranslatef(0, -16, 0);
+            GL11.glTranslatef(0, 8, 0);
+            playerRenderer.drawFirstPersonHand(Tessellator.instance, mc.thePlayer, true);
+            GL11.glPopMatrix();
             GL11.glPopMatrix();
             GL11.glPushMatrix();
             GL11.glTranslatef(-0F, -0.6F, 1.1F);
             GL11.glRotatef(-45, 1.0F, 0.0F, 0.0F);
             GL11.glRotatef(-90F + 59F, 0.0F, 0.0F, 1.0F);
             GL11.glRotatef(-65, 0.0F, 1.0F, 0.0F);
-            playerRenderer.drawFirstPersonHand(mc.thePlayer, false);
+            GL11.glPushMatrix();
+            GL11.glScalef(1/16f, 1/16f, -1/16f);
+            GL11.glTranslatef(0, 16, 0);
+            GL11.glRotatef(180, 1, 0, 0);
+            GL11.glTranslatef(0, -16, 0);
+            GL11.glTranslatef(0, 8, 0);
+            playerRenderer.drawFirstPersonHand(Tessellator.instance, mc.thePlayer, false);
+            GL11.glPopMatrix();
             GL11.glPopMatrix();
 
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 2df4fc084..d7749fae6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -4,11 +4,14 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.keyboard.KeyboardLayout;
+import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.sound.SoundRepository;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
+import org.useless.dragonfly.data.entity.mojang.EntityGeometryMojangData;
 
 import java.io.File;
 import java.io.IOException;
@@ -103,6 +106,9 @@ public class TexturePackList
 		SoundRepository.reload();
 		BlockModelDispatcher.getInstance().reload();
 		ItemModelDispatcher.getInstance().reload();
+		EntityGeometryMojangData.Cache.reload(this);
+		EntityRenderDispatcher.instance.reload();
+		TileEntityRenderDispatcher.instance.reload();
 		KeyboardLayout.defaultLayout = new KeyboardLayout();
 		TooltipElement.reloadStyles(this);
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
index 4bb35ed7d..be25210ee 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
@@ -5,10 +5,21 @@ import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityDispatcher;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.data.entity.mojang.EntityGeometryMojangData;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+
+import java.util.HashMap;
+import java.util.Map;
 
 public abstract class TileEntityRenderer<T extends TileEntity>
 {
+    private final @NotNull Map<@NotNull String, @NotNull StaticEntityModel> modelMap = new HashMap<>();
+    protected TileEntityRenderDispatcher renderDispatcher = null;
+    protected Class<? extends T> appliedClass = null;
 
     public TileEntityRenderer()
     {
@@ -17,26 +28,45 @@ public abstract class TileEntityRenderer<T extends TileEntity>
     public abstract void doRender(Tessellator tessellator, T tileEntity, double x, double y, double z,
                                   float partialTick);
 
-    protected void loadTexture(String texturePath)
+    protected void bindTexture(final String texturePath)
     {
-        TextureManager textureManager = renderDispatcher.textureManager;
+        final TextureManager textureManager = this.renderDispatcher.textureManager;
         textureManager.bindTexture(textureManager.loadTexture(texturePath));
     }
 
-    public void setRenderDispatcher(TileEntityRenderDispatcher renderDispatcher)
+    public void init(@NotNull final Class<? extends T> appliedClass, final @NotNull TileEntityRenderDispatcher renderDispatcher)
     {
         this.renderDispatcher = renderDispatcher;
+        this.appliedClass = appliedClass;
     }
 
-    public void onWorldChanged(World world)
+    public void onWorldChanged(final World world)
     {
     }
 
+    protected @NotNull StaticEntityModel getModel(@NotNull final String localId) {
+        StaticEntityModel model = this.modelMap.get(localId);
+        if (model != null) {
+            return model;
+        }
+        final NamespaceID id = TileEntityDispatcher.getIDFromClass(this.appliedClass);
+        if (id != null) {
+            model = EntityGeometryMojangData.Cache.getModelForEntity(id, localId);
+        } else {
+            model = EntityGeometryMojangData.Cache.getFallbackModel();
+        }
+        this.modelMap.put(localId, model);
+        return model;
+    }
+
+    public final @NotNull TileEntityRenderer<T> setModel(@NotNull final String localId, @NotNull final String modelId, final double inflation) {
+        this.modelMap.put(localId, EntityGeometryMojangData.Cache.getModel(modelId, inflation));
+        return this;
+    }
+
 
     public FontRenderer getFont()
     {
-        return renderDispatcher.getFont();
+        return this.renderDispatcher.getFont();
     }
-
-    protected TileEntityRenderDispatcher renderDispatcher;
 }
